import 'package:champions/champions.dart';
import 'package:test/test.dart';
import 'package:http/http.dart' as http;

void main() {
  Future<bool> checkUrl(String url) async {
    var response = await http.head(url);
    if (response.statusCode == 200) {
      print('✔ $url');
    } else {
      print('❌ $url - ${response.statusCode} ${response.reasonPhrase}');
    }

    return response.statusCode == 200;
  }

  Future<bool> championChecker(Champions champions) async {
    var all = await champions.all;
    for(var champion in all.values) {
      print('Checking assets for ${champion.name}');

      var spells = await champion.spells;

      for (var spell in spells) {
        await checkUrl(spell.clip.url);
        await checkUrl(spell.clip.thumbnail.url);
      }
    }

    return true;
  }

  test('Check latest NA champion assets', () async {
    var champions = await Champions.forRegion();
    expect(await championChecker(champions), isTrue);
  }, timeout: Timeout(Duration(minutes: 15)));
}
